/* primes.c  find primes numbers, made for arythmetics lessons in Spe Maths *
 *                                                                          *
 *   2 modes :                                                              *
 *    - prime(A) determines if A is a prime number                          *
 *    - prime(A,B) finds all prime numbers between A and B                  *
 *                                                                          *
 *   compile with tigcc and link longdiv.o and longmul.o                    *
 *                                                                          *
 * Stanowski Etienne   for any comments : Stan.Etienne@caramail.com         */

#define RETURN_VALUE

#include <nostub.h>
#include <args.h>
#include <estack.h>
#include <statline.h>

int _ti89, _ti92plus;  // Compile pour la ti89 et ti92+

typedef unsigned char Byte;
typedef long LongInt;

/* finds if it is or not a prime number */
Byte IsItPrime(LongInt Nbr)
{
  LongInt x;
  if (Nbr < 2) return FALSE;
  for (x = 2; x*x < Nbr+1; x++)
   if (Nbr % x == 0) return FALSE;
  return TRUE;
}

void _main(void)
{
  ESI ArgPtr;
  int ArgType;
  Byte NumArgs;

  InitArgPtr(ArgPtr); // initialise le pointeur

  NumArgs = ArgCount(); // donne le nbr d'argument passs

 /* vrifie que les bons arguments ont t entrs */

 if (NumArgs > 2 || (ArgType = GetArgType(ArgPtr)) == END_TAG || ArgType != POSINT_TAG
   || (NumArgs == 2 ? (ArgType = GetArgType(EX_getArg(1))) != POSINT_TAG : 0))
 {
   ST_helpMsg("Error! Usage: primes(num1,[num2])");
   push_END_TAG();
   push_quantum_pair(0x01,0xEC);
   return 0;			// arrte le programme
 }
 else
 {
   LongInt Num1 = (unsigned long) GetIntArg(ArgPtr);
   push_END_TAG();

   if (NumArgs == 1)
   {
     if (IsItPrime(Num1) == TRUE) push_quantum(TRUE_TAG); else push_quantum(FALSE_TAG);
   }
   else
   {
     LongInt i, Num2 = (unsigned long) GetIntArg(ArgPtr);
     for (i = Num2; (Num1 < Num2 ? i >= Num1 : i <= Num1); (Num1 < Num2 ? i-- : i++))
       if (IsItPrime(i) == TRUE) push_longint(i);
     push_LIST_TAG();
   }
   return 0;
 }
}
